package probe

import (
	"encoding/json"
	//"fmt"
	//"git.loafle.net/overflow/overflow_service/proxy"
	"git.loafle.net/overflow/overflow_service/proxy/member"
	"git.loafle.net/overflow/overflow_service/proxy/utils"
	"time"
)

type ProbeService struct {
}

type Probe struct {
	Id              json.Number   `json:"id,Number,omitempty"`
	AuthorizedDate  int64         `json:"authorizedDate,Number,omitempty"`
	Description     string        `json:"description,omitempty"`
	Member          member.Member `json:"member,omitempty"`
	LastPollingDate int64         `json:"lastPollingDate,omitempty"`
	Status          string        `json:"status,omitempty"`
}

func NewProbeService() *ProbeService {
	return &ProbeService{}
}

func NewAgent(desc string, member member.Member) *Probe {

	na := &Probe{
		AuthorizedDate: time.Now().Unix(),
		Description:    desc,
		Member:         member,
	}
	return na
}

func (as *ProbeService) SaveAgent(agent *Probe) (string, error) {
	//bytes, err := json.Marshal(probe)
	//if err != nil {
	//	return "", err
	//}
	//fmt.Println(probe.Member.Id)
	//fmt.Println(string(bytes))
	//paramMap := make(map[string]string)
	//paramMap["com.loafle.overflow.probe.model.Probe"] = string(bytes)
	//
	//out, err := proxy.InvokeDB("probe", "create", paramMap)

	out, err := utils.InvokeDB("probe", "create", agent)

	if err != nil {
		return "", err
	}

	return out, nil
}

func (as *ProbeService) GetAgentList(mem *member.Member) (string, error) {
	//paramMap := make(map[string]string)
	//
	//mem := member.NewMember()
	//mem.Id = json.Number(memberId)
	//
	//bytes, err := json.Marshal(mem)
	//if err != nil {
	//	return "", err
	//}
	//
	//paramMap["com.loafle.overflow.member.model.Member"] = string(bytes)
	//
	//out, err := proxy.InvokeDB("probe", "findAgentListByMemberId", paramMap)

	out, err := utils.InvokeDBByModel("probe", "findAgentListByMemberId", mem, "com.loafle.overflow.member.model.Member")

	if err != nil {
		return "", err
	}

	return out, nil
}

func (as *ProbeService) GetModel() interface{} {
	return &Probe{}
}
